Skip to content
Start here

Create routing rule

client.emailRouting.rules.create(RuleCreateParams { zone_id, actions, matchers, 3 more } params, RequestOptionsoptions?): EmailRoutingRule { id, actions, enabled, 4 more }
POST/zones/{zone_id}/email/routing/rules

Rules consist of a set of criteria for matching emails (such as an email being sent to a specific custom email address) plus a set of actions to take on the email (like forwarding it to a specific destination address).

Security

API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Email Routing Rules Write
ParametersExpand Collapse
params: RuleCreateParams { zone_id, actions, matchers, 3 more }
zone_id: string

Path param: Identifier.

maxLength32
actions: Array<Action { type, value } >

Body param: List actions patterns.

type: "drop" | "forward" | "worker"

Type of supported action.

One of the following:
"drop"
"forward"
"worker"
value?: Array<string>
matchers: Array<Matcher { type, field, value } >

Body param: Matching patterns to forward to your actions.

type: "all" | "literal"

Type of matcher.

One of the following:
"all"
"literal"
field?: "to"

Field for type matcher.

value?: string

Value for matcher.

maxLength90
enabled?: true | false

Body param: Routing rule status.

One of the following:
true
false
name?: string

Body param: Routing rule name.

maxLength256
priority?: number

Body param: Priority of the routing rule.

minimum0
ReturnsExpand Collapse
EmailRoutingRule { id, actions, enabled, 4 more }
id?: string

Routing rule identifier.

maxLength32
actions?: Array<Action { type, value } >

List actions patterns.

type: "drop" | "forward" | "worker"

Type of supported action.

One of the following:
"drop"
"forward"
"worker"
value?: Array<string>
enabled?: true | false

Routing rule status.

One of the following:
true
false
matchers?: Array<Matcher { type, field, value } >

Matching patterns to forward to your actions.

type: "all" | "literal"

Type of matcher.

One of the following:
"all"
"literal"
field?: "to"

Field for type matcher.

value?: string

Value for matcher.

maxLength90
name?: string

Routing rule name.

maxLength256
priority?: number

Priority of the routing rule.

minimum0
Deprecatedtag?: string

Routing rule tag. (Deprecated, replaced by routing rule identifier)

maxLength32

Create routing rule

import Cloudflare from 'cloudflare';

const client = new Cloudflare({
  apiEmail: process.env['CLOUDFLARE_EMAIL'], // This is the default and can be omitted
  apiKey: process.env['CLOUDFLARE_API_KEY'], // This is the default and can be omitted
});

const emailRoutingRule = await client.emailRouting.rules.create({
  zone_id: '023e105f4ecef8ad9ca31a8372d0c353',
  actions: [{ type: 'forward' }],
  matchers: [{ type: 'literal' }],
});

console.log(emailRoutingRule.id);
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "id": "a7e6fb77503c41d8a7f3113c6918f10c",
    "actions": [
      {
        "type": "forward",
        "value": [
          "destinationaddress@example.net"
        ]
      }
    ],
    "enabled": true,
    "matchers": [
      {
        "type": "literal",
        "field": "to",
        "value": "test@example.com"
      }
    ],
    "name": "Send to user@example.net rule.",
    "priority": 0,
    "tag": "a7e6fb77503c41d8a7f3113c6918f10c"
  }
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "id": "a7e6fb77503c41d8a7f3113c6918f10c",
    "actions": [
      {
        "type": "forward",
        "value": [
          "destinationaddress@example.net"
        ]
      }
    ],
    "enabled": true,
    "matchers": [
      {
        "type": "literal",
        "field": "to",
        "value": "test@example.com"
      }
    ],
    "name": "Send to user@example.net rule.",
    "priority": 0,
    "tag": "a7e6fb77503c41d8a7f3113c6918f10c"
  }
}